<?php
/************************************************************************************************************************************************************************
	File modified on 9/30/2002 for v1.0.9 - fix multiple word search navigation problem
	File modified on 5/19/2003 for v1.1.0 - for support of New Product Preview function
	File modified on 7/15/2003 for v1.2 to fix session loss when not using cookies
	File modified on 7/24/2003 for v1.2 to support running PHP with either magic_quotes_gpc On or OFF
	File modified on 9/28/2003 for v1.2 to fix option behavior problem
	File modified on 10/4/2003 for v1.2 to fix large image display link
	File modified on 10/23/2003 for v1.3.0 to fix blank product options causing MySQL errors
	File modified on 12/6/2003 for v1.4.0 to fix add to cart problem - stay pn product page no longer worked
	File modified on 3/10/2004 for v1.5.0 to fix confusion in product options - changed the separator between the option name and price from " - " to ": "
	File modified on 3/14/2004 for v1.5.0 to support new sc_query function
	File modified on 3/30/2004 for v1.5.0 to support warehouse feature
	File modified on 7/7/2004 for v1.5.0 - added support for displaying categories in different ways (diff prods per row, etc...)
	File modified on 7/27/2004 for v1.5.0 - added cart page to the page nav links...used to be just "?qry=....."
	File modified on 7/29/2004 for v1.5.0 - to fix a bug that causes products older than 1000 days to show as new
	File modified on 8/14/2004 for v1.5.0 to support discount feature
	File modified on 10/18/2004 for v1.5.0 to fix errors when linking to a deleted product
	File modified on 11/02/2004 for v2.0.0 - to reduce number of DB queries
	File modifed on 02/27/2005 for v2.0.0 - bug fix for linking to items that are no longer for sale
	File modified on 09/19/2005 for v2.0.1 - bug fix for missing image not having dimensions
	File modified on 10/03/2005 - bug fix for v2.0.1 - footer not always showing correctly for product options
	File modified on 08/05/2009 - for XSS vulnerability with product options
*************************************************************************************************************************************************************************/

// Purpose of function: return count of products in a specified category
function count_products($cat_rn){
	return count(get_products_from_category($cat_rn));
}






// Purpose: to show a product in detail
function show_product_detail($prod_rn){
	global $SC;

	// start output buffer to store output in a var.
	ob_start();
	show_product($prod_rn,$SC['templates']['product_detail']);
	
	// grab info from buffer for main template
	$Product_Detail = ob_get_contents();
	ob_end_clean();
	
	include $SC['templates']['product_detail_single'];
}







// purpose is to show a single product
// $product is an array containing the product
function show_product($prod_rn,$template=0){
	global $action,$SC,$linkto,$where,$db,$Crumb_Nav,$TD_Width,$Rank,$_GET,$crn;
	
	// missing options fields are cached here by add_to_cart()...this sets them locally, and wipes the global var.
	$missing_opts = $SC['missing_options'];
	unset($SC['missing_options']);
	
	// set variable for use in template...these are the error messages from add to cart
	if ($SC['add_cart_errors']) {
		$Errors = "<div class=\"add_cart_errors\">$SC[add_cart_errors]</div>";
		unset($SC['add_cart_errors']);
	}
	
	// set category rn....this is the category the customer is "in"
	if (is_numeric($_GET['crn'])) {
		$crn = $_GET['crn'];
	} else {
		$crn = get_field_val("REL_Products__Categories","Categories_rn","Products_rn = '$prod_rn'");
	}
	
	// set primary category for this product...this is the category that is at the top of the "Categories" field
	// on the product's record, and is the one that will be used to set various elements for this product,
	// including product options
	$primary_crn = sc_query("
		SELECT 
			Categories_rn 
		FROM 
			REL_Products__Categories
		WHERE
			Products_rn = '$prod_rn'
		ORDER BY
			Position ASC
		LIMIT 0,1
	");
	
	// grab an associative array of all data from Products table for this product
	$product = get_records("Products","*","record_number = '$prod_rn'",0,0,0,0,0,MYSQL_ASSOC,0);

	// workaround for warehouse feature change
	if (is_array($product)) $product['Number_in_Stock'] = get_sum("REL_Products__Warehouses","Stock","Products_rn = $product[record_number]");

	// if product doesn't exist, then include the product missing error template and exit out
	if (!$product || $product['Not_For_Sale'] || ($product['Number_in_Stock'] <= 0 && $SC['out_of_stock_behavior'] == 1 && $SC['inventory_control'] == 1)) {
		if ($template == $SC['templates']['product_detail']) include $SC['templates']['error_product_missing'];
		return;
	}
	
	// setup variables for use in template
	if (!$product[Not_For_Sale]) {

		// set a variable with the same name as each column name in the Products table
		foreach(array_keys($product) as $fname) $$fname = $product[$fname];
		
		//if ($show_detail) $All_Option_Details_Link = Popup_Window("$SC[cart_www_root]/product_option_details_popup.php?prn=$product[record_number]&orn=all","Option Details", 600,600,"yes","yes");

		// link to show product in more detail
		$Detail_Link = "$SC[www_cart_page]?crn=$crn&rn=$product[record_number]&action=show_detail".SID_URL;
		
		
		
		// ******************** handle Product Options *******************************************************************

		// check the template to make sure it is set to show options...if not, no sense in doing all this
		if ($template) {
			foreach(file($template) as $template_line) $template_txt .= $template_line;
			if (strstr($template_txt, '<?=$Options?>')) $show_options = true;
		} else {
			$show_options = true;
		}
		//$show_options = true;
		if ($show_options) {
			// clear cached options for this prod. record
			unset($SC['option_cache'][$prod_rn]);
			
			// set some variables
			$Required_Indicator = $SC['settings']['Required_Field_Indicator'];
			$Missing_Indicator 	= $SC['settings']['Missing_Field_Indicator'] == $Required_Indicator ? "" : $SC['settings']['Missing_Field_Indicator'];
			
			
			// grab options defined on this product's record
			$prod_opts = sc_query("
				SELECT
					o.*
					,po.record_number AS REL_rn
					,po.Options_rn
					,po.Position
				  	,po.Custom_Choices
					,'Products' AS Derived_Table
				FROM
					Options o
				INNER JOIN
					REL_Products__Options po
				ON
					o.record_number = po.Options_rn
				WHERE
					po.Products_rn = '$prod_rn'
				ORDER BY
					po.Position ASC
			", MYSQL_ASSOC, 1, 0, "Options_rn");
	
			// grab options defined on this product's primary category record
			if ($product['Merge_Options']) $cat_opts = sc_query("
				SELECT
					o.*
					,co.record_number AS REL_rn
					,co.Options_rn
					,co.Position
				  	,co.Custom_Choices
					,'Categories' AS Derived_Table
				FROM
					Options o
				INNER JOIN
					REL_Categories__Options co
				ON
					o.record_number = co.Options_rn
				WHERE
					co.Categories_rn = '$primary_crn'
				ORDER BY
					co.Position ASC
			", MYSQL_ASSOC, 1, 0, "Options_rn");
			
			// we need at least one of these arrays to be set to continue, otherwise there are no options
			if (is_array($prod_opts) || is_array($cat_opts)) {
	
				// Note: Unfortunately, the options from the product AND its primary category couldn't be
				// obtained in a single query, so this nonsense below is to work around that fact
				// 
				// Here is the gist of the logic below:
				// 
				// The keys of the 2 arrays above are the record numbers of the options from the Options table. 
				// We need to create an array containing all the (unique) keys from both arrays. Then, we will loop through them.
				// If the option was specified on the product record, we will show it based on those records ELSE
				// we will see if it was specified on the category record, and go that route instead. By doing this, the product will win out.
				// If the same option is specified for both the product AND it's primary category, the configuration of that option on the 
				// products record will be usd, and the one on the category record will be ignored.
				//
				// THE END :)
	
				// if options are on both product & category, and prod. is set to merge with category options
				if (is_array($prod_opts) && is_array($cat_opts) && $product['Merge_Options']) {
					$option_rns = array_unique(array_merge(array_keys($prod_opts), array_keys($cat_opts)));
				} elseif (is_array($prod_opts)) {
					$option_rns = array_keys($prod_opts);
				} elseif (is_array($cat_opts)) {
					$option_rns = array_keys($cat_opts);
				}
				
				// loop through each option record number
				for($x=0; $option_rns[$x]; $x++) {
					$opt_rn = $option_rns[$x];
					$opt = $prod_opts[$opt_rn] or $opt = $cat_opts[$opt_rn];
					
					if ($opt['Required']) $required_present = true; // tells code farther down that at least 1 field is required

					unset($choices,$new_choices); // cleanup
					
					// grab choices for this option
					if ($opt['Custom_Choices']) {
						
						// portion of where clause to exclude out of stock choices
						// ONLY if out of stock behavior supports it AND custom_choices is set to 1
						$out_of_stock_where = $SC['inventory_control'] && $opt['Use_Inventory_Control'] ? " AND cc.Stock >= 1" : "";
						
						$choices = sc_query("
							SELECT
								 cc.record_number
								,c.record_number AS Choices_rn
								,cc.record_number AS Custom_Choices_rn
								,c.Name
								,c.Description
								,c.Image
								,cc.Price
								,cc.Price_Operator
								,cc.Weight
								,cc.Weight_Operator
								,'Custom_Choices' AS Source_Table
							FROM 
								Choices_Custom cc
							INNER JOIN
								Choices c
							ON
								cc.Choices_rn = c.record_number
							WHERE
								cc.REL_rn = '$opt[REL_rn]'
								AND cc.Source_Table = '$opt[Derived_Table]'
								$out_of_stock_where
							ORDER BY
								cc.Position ASC
						", MYSQL_ASSOC,1);
					} else {
						
						// text/textarea/checkbox fields have only one choice, which is derived from the option itself....
						if ($opt['Type'] == "text" || $opt['Type'] == "textarea" || $opt['Type'] == "checkbox") {
							$choices[0]['record_number'] 	= $opt['record_number'];
							$choices[0]['Name'] 			= $opt['Name'];
							$choices[0]['Description'] 		= $opt['Description'];
							$choices[0]['Price'] 			= $opt['Default_Price'];
							$choices[0]['Price_Operator'] 	= $opt['Default_Price_Operator'];
							$choices[0]['Weight'] 			= $opt['Default_Weight'];
							$choices[0]['Weight_Operator'] 	= $opt['Default_Weight_Operator'];
							$choices[0]['Source_Table'] 	= "Options";
						} else { 
						
							$choices = sc_query("
								SELECT
									 c.record_number
									,c.record_number AS Choices_rn
									,c.Name
									,c.Description
									,c.Image
									,c.Default_Price AS Price
									,c.Default_Price_Operator AS Price_Operator
									,c.Default_Weight AS Weight
									,c.Default_Weight_Operator AS Weight_Operator
									,'Choices' AS Source_Table
								FROM
									Choices c
								INNER JOIN
									REL_Options__Choices oc
								ON
									c.record_number = oc.Choices_rn
								WHERE
									oc.Options_rn = '$opt_rn'
								ORDER BY
									oc.Position ASC
							", MYSQL_ASSOC, 1);
						}
					} // done setting $choices array
					
					
					// only continue w. this option if choices where found
					if (is_array($choices)) {				
						// --------- loop through choices...set a variable named $Option_Field equal to the field for this option,
						// via output buffering
						unset($Option_Field); // cleanup 
						
						//$Option_Field_Name = "options[$x]";
						$Option_Field_Name = "option_$x";
						
						// select input has an option to add a blank choice at the top...this does that
						if ($opt['Type'] == "select" && $opt['Add_Blank_Choice']) {
							if (is_array($choices)) {
								$blank_choice['record_number'] = "BLANK_CHOICE";
								$new_choices[] = $blank_choice;
								foreach($choices as $new_choice) $new_choices[] = $new_choice;
								$choices = $new_choices;
							}
						}
	
						// store options and choices in cache....add_to_cart() uses this info to decide how to handle options
						$opt['choices'] = $choices;
						$SC['option_cache'][$prod_rn][] = $opt;
	
						for($i=0; $choices[$i]; $i++) {
							
							$show_header = $i === 0 ? true : false;
							$show_footer = !$choices[$i+1] ? true : false;
							$choice = $choices[$i];
							
							if ($choice['Price_Operator'] == "plus" && $choice['Price'] > 0) {
								$Price_Operator = ": + ";
							} elseif($choice['Price_Operator'] == "minus" && $choice['Price'] > 0) {
								$Price_Operator = ": - ";
							} else {
								$Price_Operator = "";
							}
							$Choice_Value			= $opt['Type'] == "select" || $opt['Type'] == "radio" || $opt['Type'] == "checkbox" ? $i : ""; 
							$Choice_Price 			= $choice['Price'] > 0 									? $SC['currency'].$choice['Price'] 		: "";
							$Choice_Text 			= $choice['Name'].$Price_Operator.$Choice_Price;
							$Choice_Width			= $opt['Width'];
							$Choice_Height			= $opt['Height'];
							$Choice_Break			= $opt['Type'] == "radio" && $opt['Break_After_Choice'] ? "<br />"								: "";
							$Option_Price			= $opt['Type'] == "text" || $opt['Type'] == "textarea" || $opt['Type'] == "checkbox"	? $Choice_Price 						: "";
							$Option_Price_Operator 	= $opt['Type'] == "text"  || $opt['Type'] == "textarea" || $opt['Type'] == "checkbox" ? str_replace(": ","",$Price_Operator) 	: "";
							$Left_Paren				= $Option_Price ? "(" : "";
							$Right_Paren			= $Option_Price ? ")" : "";
							$Option_Type			= $opt['Type'];
							
							// this handles setting the values of the options, when the item is being edited AFTER being added to the cart
							if (is_numeric($_GET['edit_item'])) {
								$item_i = $_GET['edit_item'];
								$compare_key = "option_$x-choice_$i";
								if ($opt['Type'] == "radio" || $opt['Type'] == "select" || $opt['Type'] == "checkbox") {
									
									$selected_text = $opt['Type'] == "select" ? "selected" : "checked";
									$Choice_Selected = is_array($SC['order'][$item_i]['options'][$compare_key]) ? $selected_text : "";
								} else {
									$compare_keys = array_keys($SC['order'][$item_i]['options']);
									foreach($compare_keys as $k) {
										if (strpos($k, "option_$x-") === 0) {
											$compare_key = $k;
											break;
										}
									}
								
									if ($compare_key) {
										$Choice_Value = htmlspecialchars($SC['order'][$item_i]['options'][$compare_key]['choice']['text']);
									}
								}
							}
							
							// this handles setting the values of the options if the record was just submitted for add to cart
							// and it failed validation
							if ($_GET['add_to_cart']) {
								if ($opt['Type'] == "radio" || $opt['Type'] == "select") {
									$selected_text = $opt['Type'] == "select" ? "selected" : "checked";
									$Choice_Selected = is_numeric($_GET["option_$x"]) && $_GET["option_$x"] == $i ? $selected_text : "";
								} elseif ($opt['Type'] == "checkbox") {
									$Choice_Selected = $_GET["option_$x"] == '0' ? "checked" : "";
								} elseif ($opt['Type'] == "text" || $opt['Type'] == "textarea") {
									$Choice_Value = get_magic_quotes_gpc() ? stripslashes($_GET["option_$x"]) : $_GET["option_$x"];
									$Choice_Value = htmlspecialchars($Choice_Value);
								}
							}
							
							// handle field indicators - required, missing, etc...
							unset($Field_Indicator, $Missing_BG_Class);
							// decide whether to show required field indicator OR missing indicator
							if ($missing_opts[$x]) {
								$Field_Indicator = $SC['settings']['Missing_Field_Indicator'];
								if ($SC['settings']['Missing_Field_Colored']) {
									$Missing_BG_Class = $opt['Type'] == "radio" ? "error_field_radios" : "error_field";
								} else {
									unset($Missing_BG_Class);
								}
								$missing_present = true; // tells code farther down that at least 1 field is missing
							} elseif ($opt['Required']) {
								$Field_Indicator = $SC['settings']['Required_Field_Indicator'];
								$required_present = true; // tells code farther down that at least 1 field is required
							}
							
							// use output buffering to grab result of the include, so we can store it in a var and use it later
							ob_start(); 
	
							if ($opt['Type'] == "select") {
								include $SC['templates']['option_select'];
							
							} elseif ($opt['Type'] == "radio") {
		
								include $SC['templates']['option_radio'];
							
							} elseif ($opt['Type'] == "checkbox") {
		
								include $SC['templates']['option_checkbox'];
							
							} elseif ($opt['Type'] == "text") {
								include $SC['templates']['option_text'];
							
							} elseif ($opt['Type'] == "textarea") {
								
								include $SC['templates']['option_textarea'];
							}
							
							$Option_Field .= ob_get_contents(); 
							ob_end_clean(); 
							
						}
						// --------- END OF loop through choices...done setting up $Option_Field var ---------------------------------------
						
						
						
						
						
						// use output buffering to grab result of the include, so we can store it in a var named $Options and use it later
						// setup vars named after the columns in the Options table...prefix with "Option" to make them unique
						foreach(array_keys($opt) as $key) {
							$var_name 	= "Option_$key";
							$$var_name 	= $opt[$key];
						}
						
						// if intruction is blank, use option name
						if (!$opt['Instruction']) $Option_Instruction = $Option_Name;

						// below handles stuff to show the option detail popup page
						unset($Zoom_In_Image, $Custom_Detail_Link, $Detail_Link_Right, $Detail_Link_Left, $Extra_Br); // cleanup
						
						if ($opt['Show_Detail_Page']) {
							// the url for the detail page link...supports a custom URL
							if ($opt['Detail_Page_Content'] == "autogenerate") {
								$option_detail_url = "$SC[dyn_cart_root]/option_detail.php?REL_rn=$opt[REL_rn]&t=".strtolower($opt['Derived_Table'][0]).SID_URL;
							} else {
								$option_detail_url = $opt['Detail_Page_URL'].SID_URL;
							}
							
							if ($opt['Detail_Page_Size'] == "custom") {
								$option_detail_href = "javascript: var optDetail = window.open('$option_detail_url', 'optDetail', 'width=$opt[Detail_Page_Width], height=$opt[Detail_Page_Height], scrollbars=1')";
								$target = "";
							} else {
								$option_detail_href = $option_detail_url;
								$target = "target=\"_blank\"";
							}
							
							$detail_links = explode("^^", $opt['Detail_Links']); // turn this into an array
							if (in_array("instruction", $detail_links)) {
								$Option_Instruction = "<a href=\"$option_detail_href\" $target>$Option_Instruction</a>";
							}
		
							if (in_array("image", $detail_links)) {
								$Zoom_In_Image = " <a href=\"$option_detail_href\" $target>".get_image("Images","zoom_in")."</a>";
							}
		
							if (in_array("custom", $detail_links)) {
								$Custom_Detail_Link = " <a class=\"custom_detail_href\" href=\"$option_detail_href\" $target>$opt[Custom_Link_Text]</a>";
							}
							
							// control placement of custom detail link and image detail link
							if ($Zoom_In_Image || $Custom_Detail_Link) {
								// if placement wasn't chosen, set defaults
								if (!$opt['Detail_Link_Placement']) {
		
									switch($opt['Type']) {
										case "text":
									    case "select":
									    case "checkbox":
									    	$opt['Detail_Link_Placement'] = "right";
									    	break;
									    case "textarea":
									    case "radio":
									    	$opt['Detail_Link_Placement'] = "leftbr";
									    	break;
									    default:
									    	$opt['Detail_Link_Placement'] = "right";
									}							
								}
								
								// set fields for options.php templates, based on link placement above
								$Detail_Link_Left 	= $opt['Detail_Link_Placement'] == "left" || $opt['Detail_Link_Placement'] == "leftbr" ? true : false;
								if ($opt['Detail_Link_Placement'] == "leftbr") {
									$Detail_Br_Left_Open = "<div>";
									$Detail_Br_Left_Closed = "</div>";
								}
								$Detail_Link_Right 	= $opt['Detail_Link_Placement'] == "right" || $opt['Detail_Link_Placement'] == "rightbr" ? true : false;
								if ($opt['Detail_Link_Placement'] == "rightbr") {
									$Detail_Br_Right_Open = "<div>";
									$Detail_Br_Right_Closed = "</div>";
								}
							}
						
						} else {
							// cleanup
							unset($Extra_Br, $Zoom_In_Image, $Custom_Detail_Link, $Detail_Link_Left, $Detail_Br_Right_Open, $Detail_Br_Right_Close, $Detail_Br_Left_Open, $Detail_Br_Left_Close, $Detail_Br_Right);
							// surround instruction with span so it vertically aligns middle
							$Option_Instruction = "<span>$Option_Instruction</span>";
						}
		
						// for certain fields, if there is no link below it, we need to add a br, to make spacing correct
						if (!$Detail_Link_Right && ($opt['Type'] == "textarea" || ($opt['Type'] == "radio" && $opt['Break_After_Choice']))) {
							$Extra_Br = "<div class=\"extra_br\"></div>";
						}
						
						
						
						// next 2 lines control whether or not the table tag will show in the resulting code
						$show_header = $x === 0 			? true : false;
						$show_footer = !$option_rns[$x+1]	? true : false;
						ob_start(); 
						include $SC['templates']['options'];
						$Options .= ob_get_contents();
						ob_end_clean();
						// ---------- END OF setting up $Options var -----------------------------------------------------------------------
					}
				} // end of loop through options
			}
		}
		
		
		// ******************** END OF handling Product Options *******************************************************************
		
		
		
		
		
		
		
		
		
		// ******************** handle Sales Agreements *****************************************************************
		$agreements = get_records("REL_Products__Sales_Agreement","Sales_Agreement_rn","Products_rn = $prod_rn");
		if (is_array($agreements)) {
			foreach($agreements as $agreement) {
				$agreement_rn = $agreement['Sales_Agreement_rn'];
				$agreement = get_records("Sales_Agreement","*","record_number = $agreement_rn");
				$agreement = $agreement[0];
	
				if ($agreement) {
					unset ($file);
					// read template file into an array, and replace variables
					$lines = file($SC['templates']['sales_agreement']);
					foreach($lines as $line) $file .= $line;
					if ($agreement['Display_Name']) {
						$display_name = $agreement['Display_Name'];
					} else {
						$display_name = $agreement['Name'];
					}
					$file = str_replace('<?=$Name?>',$display_name,$file);
					$file = str_replace('<?=$Agreement?>',$agreement['Agreement'],$file);
					$file = str_replace('<?=$Width?>',$agreement['Width'],$file);
					$file = str_replace('<?=$Height?>',$agreement['Height'],$file);
					$file = str_replace('<?=$Print_Agreement_HREF?>',$SC['cart_www_root']."/sales_agreement.php?agreement_rn=$agreement_rn".SID_URL,$file);
	
					$Agreement .= $file;
				}
			}
		}
		// ****************** END OF section to handle sales agreements **************************************************
	
		
		
		
		// check to see if image files really exist
		$img_srv_path 		= "$SC[site_isp_root]/$SC[image_folder]/$Image";
		$thumb_img_srv_path = "$SC[site_isp_root]/$SC[image_folder]/$Thumbnail_Image";
		
		// if file is missing, use the missing_image image
		if (!is_file($img_srv_path)) {
			$Image 			= $SC['settings']['Missing_Image'];
			$img_srv_path 	= "$SC[site_isp_root]/$SC[image_folder]/$Image";
		}

		// set dimensions for use in template
		$image_dims 	= getimagesize($img_srv_path);
		$Image_Width 	= $image_dims[0];
		$Image_Height 	= $image_dims[1];
		
		// if file is missing, use the missing_image image
		if (!is_file($thumb_img_srv_path)) {
			$Thumbnail_Image 	= $SC['settings']['Missing_Thumbnail_Image'];
			$thumb_img_srv_path = "$SC[site_isp_root]/$SC[image_folder]/$Thumbnail_Image";
		}

		// set dimensions for use in template
		$image_dims 	= getimagesize($thumb_img_srv_path);
		$Thumbnail_Image_Width 	= $image_dims[0];
		$Thumbnail_Image_Height 	= $image_dims[1];

		if($SC['secure_page']) {
			$image_root = $SC['site_secure_root'];
		} else {
			$image_root = $SC['site_www_root'];
		}
		
		$Thumbnail_Image 		= "$image_root/".$SC["image_folder"]."/$Thumbnail_Image";
		$Image 					= "$image_root/".$SC["image_folder"]."/$Image";
		$Large_Image_true 		= "$SC[site_isp_root]/".$SC["image_folder"]."/$Large_Image";
		$Large_Image 			= "$image_root/".$SC["image_folder"]."/$Large_Image";
		$add_to_cart_behavior 	= $SC['settings']['Add_to_Cart_Behavior'];

		// handle add to cart behavior
		if($add_to_cart_behavior == "go to checkout") {
			$Form_Action = $SC['www_cart_page'];
			$Show_Cart = "<input type=\"hidden\" name=\"show_cart\" value=\"1\">";
		} else {
			$Show_Cart = "<input type=\"hidden\" name=\"crn\" value=\"$_GET[crn]\">";
			$Show_Cart .= "<input type=\"hidden\" name=\"rn\" value=\"$prod_rn\">";
			$Show_Cart .= "<input type=\"hidden\" name=\"action\" value=\"$_GET[action]\">";
		}

		if(is_file($Large_Image_true)) {
			$Large_Image_HREF = $Large_Image ;
			$Image_in_Large_Image_Link = "<a href=\"$Large_Image_HREF\" target=\"new\"><img border=\"0\" src=\"$Image\" width=\"$Image_Width\" height=\"$Image_Height\" /></a>";
		} else {
			$Large_Image_HREF = "#";
			$Image_in_Large_Image_Link = "<img border='0' src='$Image'>";
		}
		
		$Featured_Image = "$SC[site_www_root]/".$SC["image_folder"]."/$Featured_Image";

		if(security_level("Store Admin")){
			$Admin_Link = "<a class=\"small_link\" href=\"$SC[www_admin_page]?edit_records=1&selected_record_number=$product[record_number]&table=Products".SID_URL."\">(edit)</a>";
		} else {
			unset($Admin_Link);
		}
		
		/*********************************************************************
			Handle discounts for products
		*********************************************************************/
		
		// grab discount info
		$discount = get_discount('product',$prod_rn);
		// we are only doing this for show, so if it's a buy x get y, we can't show the sale price
		if ($discount['buy_x_get_y'] == 'true') unset($discount);
		
		if($product['Show_Base_Price']) {
			$Currency_Symbol = $SC['currency'];
			if ($discount) {
				$Regular_Price 		= $Base_Price;
				$Base_Price 		= $discount['discount_price'];
				$Discount_Price 	= $discount['discount_price'];
				$Savings_Amount 	= $discount['savings_amt'];
				$Savings_Percent 	= $discount['savings_percent'];
			}
			if ($discount['price_label']) {
				$Price_Label = $discount['price_label'];
			} else {
				$Price_Label = $SC['settings']['Base_Price'];
			}
			
			$Base_Price = sc_money_format($Base_Price,1);
			
		} else {
			unset($Base_Price);
		}

		$Microtime 			= microtime();		// add field to assist in making sure multiple adds to the cart don't happen when you click "back"
		$Add_to_Cart_img 	= is_numeric($_GET['edit_item']) ? get_image("Images","update_cart_button",0,0,1) : get_image("Images","add_to_cart",0,0,1);
		$Quantity_Value 	= is_numeric($_GET['edit_item']) ? $SC['order'][$_GET['edit_item']]['qty'] : 1;
		$Update_Item		= is_numeric($_GET['edit_item']) ? $_GET['edit_item'] : "";
		$Continue_Image 	= get_image("Images","continue_button",0,0,1);
		$Name_Fixed 		= htmlspecialchars($Name);
		$Hidden_Fields = "
			<input type=\"hidden\" name=\"add_to_cart\" 	value=\"1\">
			<input type=\"hidden\" name=\"prod_rn\" 		value=\"".$product["record_number"]."\">
			<input type=\"hidden\" name=\"prod_name\" 		value=\"$Name_Fixed\">
			<input type=\"hidden\" name=\"microtime\" 		value=\"$Microtime\">
			<input type=\"hidden\" name=\"update_item\" 	value=\"$Update_Item\">
			<input type=\"hidden\" name=\"edit_item\" 		value=\"$_GET[edit_item]\">
		";
		$Add_to_Cart = "$Hidden_Fields
		<input type=\"image\" src=\"$Add_to_Cart_img\">\r";

		// if inventory control is enabled, and item is out of stock
		if($SC['inventory_control'] && $product['Number_in_Stock'] < 1){
			$out_of_stock_ind = $SC['settings']['Out_of_Stock_Indicator'];
			if ($SC['out_of_stock_behavior']=="3") $Add_to_Cart = $out_of_stock_ind;
			if ($SC['out_of_stock_behavior']=="4") $Add_to_Cart = $out_of_stock_ind.$Add_to_Cart;
		}
				


		// below checks to see if product is new based on "New" record in the Admin_Options table
		$today=date("Y-m-d H:i:s"); 
		$today=strtotime($today);
		$product_date=$product["Date_Added_to_Cart"];
		$product_date=strtotime($product_date);
		$date_difference=(($today - $product_date)/86400); 
		$new_length = $SC['settings']['New'];
		$date_difference = number_format($date_difference, 0,"","");			// strip decimal places to make age of product in days a whole number

		if($new_length){
			if($new_length >= $date_difference) {
				$New = get_image("Images","new");
			} else {
				unset($New);
			}
		}								
		
		if (!$template){
			if ($action=="show") {
				if ($discount['template'] == "discount") {
					$template = $SC['templates']['product_thumbnail_discount'];
				} else {
					$template = $SC['templates']['product_thumbnail'];
				}
			}
		} else {

			// if template is already set, see if one is set in the discount record...if so, use it, if not, use what $template is already set to
			if ($template == $SC['templates']['product_detail'] && $discount['template']) {
				if ($discount['template'] == "discount") $template = $SC['templates']['product_detail_discount'];
			}
			if ($template == $SC['templates']['product_thumbnail'] && $discount['template']) {
				if ($discount['template'] == "discount") $template = $SC['templates']['product_thumbnail_discount'];
			}
		}

		
		if ($SC['secure_page']) {
			$ThemeDir = $SC['theme_secure_dir'];
		} else {
			$ThemeDir = $SC['theme_www_dir'];
		}
		include $template;
	
		// display all possible discounts for this product
		if ($action == "show_detail" && ($template == $SC['templates']['product_detail'] || $template == $SC['templates']['product_detail_discount'])) {
			show_discounts("product_detail",$prod_rn);
		}
	}
}
/******************** END OF show_product() ************************************************************************/

















/**************************************************************************************************************************

	Purpose: output table rows containing products

	Parameters:
		$query		- either a category record number OR
					  a string containing an SQL query that will return the record numbers of the products to display
		$tpl_main	- path to the main product template file
		$tpl_sep	- path to separator template - shown in between each row of products
		$tpl_row	- controls each row of products

**************************************************************************************************************************/

function show_products($query, $tpl_main=0, $tpl_sep=0, $prods_per_row=0, $prods_per_page=0, $page_nav_url=0, $orderby=0, $orderhow=0,$randomize=0,$tpl_row=0,$tpl_td_empty=0){
	global $SC,$_GET;
	
	// set defaults if needed
	$tpl_main 		= is_file($tpl_main)			? $tpl_main 			: $SC['templates']['product_thumbnail'];
	$tpl_sep 		= is_file($tpl_sep)				? $tpl_sep	 			: $SC['templates']['product_thumbnail_separator'];
	$tpl_row 		= is_file($tpl_row)				? $tpl_row	 			: $SC['templates']['product_thumbnail_row'];
	$tpl_td_empty 	= is_file($tpl_td_empty)		? $tpl_td_empty 		: $SC['templates']['product_thumbnail_td_empty'];
	$prods_per_row 	= $prods_per_row 				? $prods_per_row		: $SC['settings']['Products_per_Row'];
	$prods_per_row	= $prods_per_row 				? $prods_per_row		: 2; 
	if (!$prods_per_row) $prods_per_row = 2;
	$prods_per_page	= $prods_per_page 				? $prods_per_page 		: $SC['settings']['Products_per_Page'];
	$orderby		= $orderby 						? $orderby				: $SC['settings']['Order_Products_By'];
	$orderhow		= $orderhow 					? $orderhow				: $SC['settings']['Order_Products_How'];
	$orderhow		= $orderhow == 'Ascending' 		? 'ASC' 				: 'DESC';	// reformat the orderhow var...it will be something like "Ascending" b4 reformatting
	$crn			= is_numeric($query) 			? $query 				: $_GET['crn'];
	
	// fix prods per page IF it is less than prods_per_row
	if ($prods_per_page < $prods_per_row) $prods_per_page = $prods_per_row;
	
	// record to start at
	$start_record = is_numeric($_GET['start']) ? ($_GET['start'] * $prods_per_page) - $prods_per_page : 0;


	// if $query is a category record number, then the section below sets up the qry to show all products in that category
	// category rn# 1 is the special "New Products" category, and needs a special query
	if ($query == 1) {
		// get date cutoff, and number of items to show when previewing new items
		$cutoff_days = is_numeric($SC['settings']['New']) ? $SC['settings']['New'] : 14;
		
		if ($cutoff_days == 0) $cutoff_days = -1;
		
		// get current date in UNIX timestamp, and convert it to MySQL format, in $cutoff_date
		$cutoff_unix_date = mktime (0,0,0,date("m")  ,date("d")-$cutoff_days,date("Y"));
		$cutoff_date = date("Y-m-d",$cutoff_unix_date);

		// below line will exclude out of stock items, if specified to do so in store settings
		$where = "Not_for_Sale <> 1 AND Date_Added_to_Cart >= '$cutoff_date'";

		// setup variables to add clauses to qry for inventory control,
		// if it is enabled and set to not show out of stock items
		if($SC['inventory_control'] && $SC['out_of_stock_behavior'] == "1") {
			$stock_join = '
				RIGHT JOIN 
			    	REL_Products__Warehouses pw 
				ON
					p.record_number = pw.Products_rn
			';
			$stock_where = 'AND pw.Stock > 0';
			$stock_group_by = 'GROUP BY pw.Products_rn';
		}

		$order_by_clause = $randomize ? 'ORDER BY RAND()' : "ORDER BY $orderby $orderhow";
		
		$query = "
			SELECT
			    p.record_number
			FROM 
				Products p 
			$stock_join
			WHERE
				$where
				$stock_where
			$stock_group_by
			$order_by_clause
		";
		
	} elseif (is_numeric($query)) {
		
		
		// if inventory control is enabled, set some variables to add to the query	
		if($SC['inventory_control'] && $SC['out_of_stock_behavior'] == "1") {
			$inventory_join = '
				INNER JOIN
					REL_Products__Warehouses rel_p_w 
				ON
					rel_p_w.Products_rn = prod.record_number
			';
			
			$inventory_where = ' AND rel_p_w.Stock > 0';
		
		}

		// set order by clause
		$order_by_clause = $randomize ? 'ORDER BY RAND()' : "ORDER BY prod.$orderby $orderhow";
		
		$query = "
			SELECT
				prod.record_number
				#,cat.record_number AS Category
			FROM
				Products prod
			INNER JOIN
				REL_Products__Categories rel_p_c
			ON
				rel_p_c.Products_rn = prod.record_number
			INNER JOIN
				Categories cat
			ON
				rel_p_c.Categories_rn = cat.record_number
			$inventory_join
			WHERE 
				cat.record_number = $query
				AND prod.Not_For_Sale != 1
				$inventory_where
				# $exclude
			GROUP BY 
				prod.record_number
				#rel_p_w.Products_rn
			$order_by_clause
		";
	}
	/************ done setting up default query for viewing a category **************/
	
	
	// count total records for this query
	$temp = sc_query($query,MYSQL_ASSOC,1);
	if (is_array($temp)) {
		$number_of_products = count($temp);
		// cleanup
		unset($temp);
	}
	
	// add the limit clause to the end of this puppy ONLY if it does not already have a limit clause
	if (!strstr($query,'LIMIT ')) $query .= " LIMIT $start_record, $prods_per_page";
	
	// run query to grab products
	$prod_rns = sc_query($query,MYSQL_ASSOC,1);

	// bail if query was N/G
	if (!is_array($prod_rns)) return;
	
	/************ show products ************************************************/
	
	// calculate width for TD based on prods per row
	if ($number_of_products < $prods_per_row && $number_of_products) {
		$TD_Width = round(100 / $number_of_products);
	} else {
		$TD_Width = round(100 / $prods_per_row);
	}
	$TD_Width .= '%';
	// needs to be global...forget why :)
	$GLOBALS['TD_Width'] = $TD_Width;
	
	
	// loop through each product and show 'em
	for($x=0;$prod_rns[$x];$x++) {
		$prod_rn = $prod_rns[$x]['record_number'];
		
		// use output buffering to grab HTML for a single product TD and append to $Product_TDs variable
		ob_start();
		if (is_numeric($prod_rn)) {
			show_product($prod_rn,$tpl_main);
		}
		$Product_TDs .= ob_get_contents();
		ob_end_clean();
		
		// track the number of products we displayed, until we reach the $prods_per_row setting
		$prods_this_row++;
		
		// if we have enough cells to fill row, or we are on the last cell
		if ($prods_this_row == $prods_per_row || !$prod_rns[$x+1]) {

			// if on the last cell, and the row isn't full
			if (!$prod_rns[$x+1] && $prods_this_row < $prods_per_row) {
			
				// grab the code for the empty td
				ob_start();
				include $tpl_td_empty;
				$empty_td = ob_get_contents();
				ob_end_clean();
								
				// loop and fill in the gap with blank TDs
				while($prods_this_row < $prods_per_row) {
					$Product_TDs .= $empty_td;
					$prods_this_row ++;
				}

			}

			// Store row in array IF we've shown enough products
			ob_start();
			include $tpl_row;
			$prod_rows[] = ob_get_contents();
			ob_end_clean();
			
			// cleanup $Product_TDs for next loop
			unset($Product_TDs);
			
			// reset prods_this_row for next loop
			$prods_this_row = 0;
		}
	}
	
	// grab code for separation between rows from template
	ob_start();
	include $tpl_sep;
	$row_sep = ob_get_contents();
	ob_end_clean();	

	// stick separator in between each row, and print them
	print implode($row_sep,$prod_rows);
	
	/*********** Page Navigation ************************************************/

	// setup page nav IF there are more products than we can display on 1 page
	if ($number_of_products > $prods_per_page) {

		// figure out the page that we are currently on
		$current_page = $_GET['start'] ? $_GET['start'] : 1;
		
		// figure out the number of pages we need to show links for
		$number_of_pages = ceil($number_of_products / $prods_per_page);
		
		// set the URL we will use for the base of the page link...this can be passed in as $page_nav_url
		$page_nav_url = $page_nav_url ? $page_nav_url : "$SC[dyn_cart_page]?crn=$crn";
		
		// loop through once for each page
		while($number_of_pages > $page_count) {
			// this incremements how many pages we've dealt with
			$page_count++;
			
			if ($current_page == $page_count) {
				$Page_Links .= '<span class="page_nav_current page_nav_spacing">'.$page_count.'</span>'."\n";
			} else {
				$Page_Links .= "<a class=\"page_nav_spacing\" href=\"$page_nav_url&start=$page_count\">$page_count</a>\n";
			}
		}
		
		// set the links for the next page, and previous
		$Next_Page_URL 		= ($current_page + 1) <= $number_of_pages ? 	"$page_nav_url&start=".($current_page + 1) : false;
		$Previous_Page_URL	= ($current_page - 1) > 0 ? 					"$page_nav_url&start=".($current_page - 1) : false;
		
		ob_start();
		include $SC['templates']['page_navigation'];
		$result['page_nav'] = ob_get_contents();
		ob_end_clean();
	}	
	
	// include footer template
	//include $tpl_foot;
	
	// add some data to result array
	$result['number_of_products'] 	= $number_of_products;
	
	//sc_print_array($prod_rns);
	return $result;
}

?>